package tools.descartes.dql.connector.kieker.tests.list;

import static org.junit.Assert.assertEquals;

import org.eclipse.xtext.junit4.InjectWith;
import org.eclipse.xtext.junit4.XtextRunner;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;

import tools.descartes.dql.connector.kieker.tests.AbstractListQueryTest;
import tools.descartes.dql.lang.DescartesQLInjectorProvider;
import tools.descartes.dql.lang.descartesQL.ListQuery;

@RunWith(XtextRunner.class)
@InjectWith(DescartesQLInjectorProvider.class)
public class ListEntitiesQuery extends AbstractListQueryTest {
	public static final String MODEL_LOCATION = "kieker@/tools.descartes.dql.connector.kieker.tests/fixtures/Queries/kiekerDql.properties";
	public static final String MODE = "ENTITIES";

	@Override
	@Before
	public void initializeTest() throws Exception {
		super.initialize(createFileName("fixtures/Queries", this.getClass().getSimpleName()));
	}

	@Override
	@Test
	public void testFilterClause() {
		testNotNullFilterClause();
	}

	@Override
	@Test
	public void testListQueryMode() {
		final ListQuery list = getListQuery(getQuery());

		final tools.descartes.dql.lang.descartesQL.ListEntitiesQuery listEntities = (tools.descartes.dql.lang.descartesQL.ListEntitiesQuery) list
				.getQueryType();

		assertEquals("Mode not set correctly", MODE, listEntities.getMode());
	}

	@Override
	@Test
	public void testUsingClause() {
		testUsingClause(getListQuery(getQuery()).getUsingClause());
	}
}
