package tools.descartes.dql.connector.kieker.structures.classes;


public class ClassMapKey {
	private final String hostID;
	private final String classID;
	private final String requestID;
	
	public ClassMapKey(String hostID, String classID, String requestID){
		this.hostID = hostID;
		this.classID = classID;
		this.requestID = requestID;
	}


	public String getHostID() {
		return hostID;
	}


	public String getClassID() {
		return classID;
	}

	public String getRequestID(){
		return requestID;
	}

	@Override //class ID length is set to 30; 
	public String toString(){
		//return String.format("@[%1$s] %2$-30s \t by request \"%3$s\";", hostID, classID,requestID);
		return String.format("@[%s] %s \t| requestID: %s", hostID, classID,requestID);
	}


	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((classID == null) ? 0 : classID.hashCode());
		result = prime * result
				+ ((hostID == null) ? 0 : hostID.hashCode());
		return result;
	}


	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ClassMapKey other = (ClassMapKey) obj;
		if (classID == null) {
			if (other.classID != null)
				return false;
		} else if (!classID.equals(other.classID))
			return false;
		if (hostID == null) {
			if (other.hostID != null)
				return false;
		} else if (!hostID.equals(other.hostID))
			return false;
		return true;
	}


}
